!define VERSION "0.60"
!define DLL_PATH "c:\program files\nsis\autorun\dll"

Function .onInit
	SetOutPath $EXEDIR
	ReadINIStr $1 $EXEDIR\autorun.ini image show
	StrCmp $1 "yes" 0 skipImage
		ReadINIStr $2 $EXEDIR\autorun.ini image millisec
		ReadINIStr $3 $EXEDIR\autorun.ini image file
		Exec 'splash.exe $2 $HWNDPARENT $3'

	skipImage:
FunctionEnd


Function GetWindowsVersion
  Push $9
  ReadRegStr $0 HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" CurrentVersion
  StrCmp $0 "" 0 lbl_winnt
  ; we are not NT.
  ReadRegStr $0 HKLM SOFTWARE\Microsoft\Windows\CurrentVersion VersionNumber
 
  StrCpy $9 $0 1
  StrCmp $9 '4' 0 lbl_error

  StrCpy $9 $0 3

  StrCmp $9 '4.0' lbl_win32_95
  StrCmp $9 '4.9' lbl_win32_ME lbl_win32_98

  lbl_win32_95:
    StrCpy $0 '95'
  Goto lbl_done

  lbl_win32_98:
    StrCpy $0 '98'
  Goto lbl_done

  lbl_win32_ME:
    StrCpy $0 'ME'
  Goto lbl_done

  lbl_winnt: 

    StrCpy $9 $0 1
    StrCmp $9 '3' lbl_winnt_x
    StrCmp $9 '4' lbl_winnt_x
    StrCmp $9 '5' lbl_winnt_5 lbl_error

    lbl_winnt_x:
      StrCpy $0 "NT $0" 6
    Goto lbl_done

    lbl_winnt_5:
			StrCpy $9 $0 3
			StrCmp $9 '5.1' lbl_winnt_5.1
      StrCpy $0 '2000'
    Goto lbl_done

		lbl_winnt_5.1:
      StrCpy $0 'XP'
    Goto lbl_done


  lbl_error:
    Strcpy $0 ''
  lbl_done:
  Pop $9
FunctionEnd



Function checkMDVD
	ClearErrors
	ReadRegStr $INSTDIR HKEY_CURRENT_USER "Software\Tiamat Software\Micro DVD Player" "InstallPath" ; 1.2
	IfErrors MDVD12NotFound
	StrCmp $INSTDIR $EXEDIR MDVD12NotFound
	IfFileExists $INSTDIR\mdvdp.exe 0 MDVD12NotFound
		Exec '"$INSTDIR\mdvdp.exe" "$EXEDIR\mdvd.ini"'
	goto EndIf

	MDVD12NotFound:
		ClearErrors
		ReadRegStr $INSTDIR HKEY_LOCAL_MACHINE "SOFTWARE\Tiamat Software\Micro DVD Player" "InstallPath" ; 1.1
		IfErrors MDVDNotFound
		StrCmp $INSTDIR $EXEDIR MDVDNotFound
		IfFileExists $INSTDIR\mdvdp.exe 0 MDVDNotFound
			MessageBox MB_YESNO "Micro DVD Player 1.1 found.$\nDo u want to upgrade it to 1.2?" IDYES Install
				Exec '"$INSTDIR\mdvdp.exe" "$EXEDIR\mdvd.ini"'
	goto EndIf

	Install:
		ReadINIStr $1 $EXEDIR\autorun.ini MDVDP InstallDirectory
		ReadINIStr $2 $EXEDIR\autorun.ini MDVDP InstallFile
		;MessageBox MB_OK "$EXEDIR\$1\$2"
		ExecWait '"$EXEDIR\$1\$2"'
	goto EndIf

	MDVDNotFound:
		MessageBox MB_YESNO "Micro DVD not found.$\nDo you want to install it?$\n(If u press NO, Micro DVD Player will run from CD)." IDYES Install
			Exec '"$EXEDIR\mdvdp.exe" "$EXEDIR\mdvd.ini"'

	EndIf:
FunctionEnd



Function checkCodecs
	ReadINIStr $1 $EXEDIR\autorun.ini codecVideo check
	StrCmp $1 "yes" 0 audioCheck
		ReadINIStr $1 $EXEDIR\autorun.ini codecVideo type
		StrCmp $1 "divx3" checkDivX3
		StrCmp $1 "divx4" checkDivx4
		StrCmp $1 "divx5" checkDivx5
			MessageBox MB_OK "Video Codec Check not possible, maybe there is a syntax error in autorun.ini."
	goto audioCheck

	checkDivX3:
		Call checkDivX3.11
	goto audioCheck

	checkDivX4:
		Call checkDivX4.01
	goto audioCheck

	checkDivX5:
		Call checkDivX5.02
	goto audioCheck

	audioCheck:
		ReadINIStr $1 $EXEDIR\autorun.ini codecAudio check
		StrCmp $1 "yes" 0 endAllCheck
			ReadINIStr $1 $EXEDIR\autorun.ini codecAudio type
			StrCmp $1 "divxaudio" checkDivXAudio
			StrCmp $1 "mp3" checkMp3
			;StrCmp $1 "ac3" checkAc3
			;StrCmp $1 "wma" checkWma
				MessageBox MB_OK "Audio Codec Check not possible, maybe there is a syntax error in autorun.ini."
	goto endAllCheck

	checkDivXAudio:	
		StrCmp $0 "2000" checkDivXAudio2000 checkDivXAudio98Me

		checkDivXAudio2000:
			ReadRegStr $1 HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Drivers32" "msacm.divxa32"
			call checkDivXAudio
		goto endAllCheck
		
		checkDivXAudio98Me:
			ReadINIStr $1 $WINDIR\system.ini drivers32 msacm.divxa32
			call checkDivXAudio
		goto endAllCheck
		

	checkMp3:
		StrCmp $0 "2000" checkMp3Audio2000 checkMp398MeAudio

		checkMp3Audio2000:
			ReadRegStr $1 HKEY_LOCAL_MACHINE "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Drivers32" "msacm.l3acm"
			call checkMp3Audio
		goto endAllCheck

		checkMp398MeAudio:
			ReadINIStr $1 $WINDIR\system.ini drivers32 msacm.l3acm
			call checkMp3Audio
		goto endAllCheck

	endAllCheck:
FunctionEnd




Function checkDivX3.11 ;works under w2k and w98
	ReadRegStr $3 HKEY_LOCAL_MACHINE "SOFTWARE\Classes\CLSID\{82CCD3E0-F71A-11D0-9FE5-00609778AAAA}\InProcServer32" ""

	IfFileExists $SYSDIR\$3 0 videoDecoderNotFound
		GetDLLVersionLocal "${DLL_PATH}\divx3\divx_c32.ax" $6 $7
		GetDLLVersion $SYSDIR\$3 $8 $9
		IntCmp $6 $8 0 0 tryDivX4
		IntCmp $7 $9 0 0 tryDivX4
		;CompareDLLVersions /STOREFROM d:\divxtools\divx311\DIVX_C32.AX $SYSDIR\$3 tryDivX4 0
		;MessageBox MB_OK "Video Codec DivX ;-) 3.11 Alpha found..."
	goto end3.11VideoCheck

	videoDecoderNotFound:
		SetOutPath "C:\"
		IfFileExists $3 0 tryDivX4
			GetDLLVersionLocal "${DLL_PATH}\divx3\divx_c32.ax" $6 $7
			GetDLLVersion $3 $8 $9
			IntCmp $6 $8 0 0 tryDivX4
			IntCmp $7 $9 0 0 tryDivX4
			;CompareDLLVersions /STOREFROM d:\divxtools\divx311\DIVX_C32.AX $3 tryDivX4 0
	goto end3.11VideoCheck

	tryDivX4:
		call checkDivX4.01
	goto end3.11VideoCheck

	end3.11VideoCheck:
	SetOutPath $EXEDIR
FunctionEnd




Function checkDivX4.01 ;i think this works under w2k and w98
	ReadRegStr $3 HKEY_LOCAL_MACHINE "SOFTWARE\Classes\CLSID\{78766964-0000-0010-8000-00AA00389B71}\InProcServer32" ""
	
	IfFileExists $SYSDIR\$3 0 videoDecoderNotFound
		GetDLLVersionLocal "${DLL_PATH}\divx4\divxdec.ax" $6 $7
		GetDLLVersion $SYSDIR\$3 $8 $9
		IntCmp $6 $8 0 0 askToInstallVideo
		IntCmp $7 $9 0 0 askToInstallVideo
		;CompareDLLVersions /STOREFROM d:\divxtools\divx4\DivXdec.ax $SYSDIR\$3 askToInstall 0
		;MessageBox MB_OK "Video Codec DivX 4 found..."
	goto end4VideoCheck

	videoDecoderNotFound:
		SetOutPath "C:\"
		IfFileExists $3 0 askToInstallVideo
			GetDLLVersionLocal "${DLL_PATH}\divx4\divxdec.ax" $6 $7
			GetDLLVersion $3 $8 $9
			IntCmp $6 $8 0 0 askToInstallVideo
			IntCmp $7 $9 0 0 askToInstallVideo
			;CompareDLLVersions /STOREFROM d:\divxtools\divx4\DivXdec.ax $3 askToInstall 0
			;MessageBox MB_OK "Video Codec DivX 4 found... (2)"
	goto end4VideoCheck

	askToInstallVideo:
		MessageBox MB_YESNO "I can't find the right Codec.$\n(Video Codecs)$\nDo u want to install it, now?" IDNO end4VideoCheck
		call installCodecVideo
	goto end4VideoCheck


	end4VideoCheck:
	SetOutPath $EXEDIR
FunctionEnd


Function checkDivX5.02
	ReadRegStr $3 HKEY_LOCAL_MACHINE "SOFTWARE\Classes\CLSID\{78766964-0000-0010-8000-00AA00389B71}\InProcServer32" ""
	
	IfFileExists $SYSDIR\$3 0 videoDecoderNotFound
		GetDLLVersionLocal "${DLL_PATH}\divx5\divxdec.ax" $6 $7
		GetDLLVersion $SYSDIR\$3 $8 $9
		IntCmp $6 $8 0 0 askToInstallVideo
		IntCmp $7 $9 0 0 askToInstallVideo
		;MessageBox MB_OK "Video Codec DivX 5 found..."

	videoDecoderNotFound:
		SetOutPath "C:\"
		IfFileExists $3 0 askToInstallVideo
			GetDLLVersionLocal "${DLL_PATH}\divx5\divxdec.ax" $6 $7
			GetDLLVersion $3 $8 $9
			IntCmp $6 $8 0 0 askToInstallVideo
			IntCmp $7 $9 0 0 askToInstallVideo
	goto end5VideoCheck

	askToInstallVideo:
		MessageBox MB_YESNO "I can't find the right Codec.$\n(Video Codecs)$\nDo u want to install it, now?" IDNO end5VideoCheck
		call installCodecVideo
	goto end5VideoCheck

	end5VideoCheck:
	SetOutPath $EXEDIR
FunctionEnd



Function checkDivXAudio
	IfFileExists $SYSDIR\$1 0 audioDecoderNotFound
		GetDLLVersionLocal "${DLL_PATH}\divx3\divxa32.acm" $6 $7
		GetDLLVersion $SYSDIR\$1 $8 $9
		IntCmp $6 $8 0 0 askToInstallDivXAudio
		IntCmp $7 $9 0 0 askToInstallDivXAudio
		;CompareDLLVersions /STOREFROM d:\divxtools\divx311\DIVXA32.ACM $SYSDIR\$1 askToInstall 0
		;MessageBox MB_OK "Audio Codec DivX ;-) 3.11 Alpha found..."
	goto endDivXAudioCheck

	audioDecoderNotFound:
	SetOutPath "C:\"
	IfFileExists $1 0 askToInstallDivXAudio
		GetDLLVersionLocal "${DLL_PATH}\divx3\divxa32.acm" $6 $7
		GetDLLVersion $1 $8 $9
		IntCmp $6 $8 0 0 askToInstallDivXAudio
		IntCmp $7 $9 0 0 askToInstallDivXAudio
		;CompareDLLVersions /STOREFROM d:\divxtools\divx311\DIVXA32.ACM $1 askToInstallAudio 0
	goto endDivXAudioCheck

	askToInstallDivXAudio:
		MessageBox MB_YESNO "I can't find the right Codec.$\n(Audio Codecs)$\nDo u want to install it, now?" IDNO endDivxAudioCheck
		call installCodecAudio
	goto endDivXAudioCheck

	endDivXAudioCheck:
	SetOutPath $EXEDIR
FunctionEnd



Function checkMp3Audio
	IfFileExists $SYSDIR\$1 0 mp3DecoderNotFound
		GetDLLVersionLocal "${DLL_PATH}\mp3\l3codeca.acm" $6 $7
		GetDLLVersion $SYSDIR\$1 $8 $9
		IntCmp $6 $8 0 0 askToInstallMp3
		IntCmp $7 $9 0 0 askToInstallMp3
		;MessageBox MB_OK "Audio Codec MP3 found..."
	goto endMp3AudioCheck
		
	mp3DecoderNotFound:
	SetOutPath "C:\"
	IfFileExists $1 0 askToInstallMp3
		GetDLLVersionLocal "${DLL_PATH}\mp3\l3codeca.acm" $6 $7
		GetDLLVersion $1 $8 $9
		IntCmp $6 $8 0 0 askToInstallMp3
		IntCmp $7 $9 0 0 askToInstallMp3
	goto endMp3AudioCheck

	askToInstallMp3:
		MessageBox MB_YESNO "I can't find the right Codec.$\n(Audio Codecs)$\nDo u want to install it, now?" IDNO endMp3AudioCheck
		call installCodecAudio
	goto endMp3AudioCheck

	endMp3AudioCheck:
	SetOutPath $EXEDIR
FunctionEnd



Function installCodecVideo
	SetOutPath $EXEDIR
	ReadINIStr $1 $EXEDIR\autorun.ini CodecVideo InstallDirectory
	ReadINIStr $2 $EXEDIR\autorun.ini CodecVideo InstallFile
	ExecWait '"$EXEDIR\$1\$2"'
FunctionEnd


Function installCodecAudio
	SetOutPath $EXEDIR
	ReadINIStr $1 $EXEDIR\autorun.ini CodecAudio InstallDirectory
	ReadINIStr $2 $EXEDIR\autorun.ini CodecAudio InstallFile
	ExecWait '"$EXEDIR\$1\$2"'
FunctionEnd



Name "autorun"
Caption "kMDVDrun ${VERSION}"
OutFile autorun.exe
Icon divx.ico
SilentInstall silent

;InstallDirRegKey HKEY_LOCAL_MACHINE "SOFTWARE\Tiamat Software\Micro DVD Player" "InstallPath" ;1.1
InstallDirRegKey HKEY_CURRENT_USER "Software\Tiamat Software\Micro DVD Player" "InstallPath" ;1.2

Section ; default section
		Call getWindowsVersion
		StrCmp $0 "NT 3" checkNotPossible
		StrCmp $0 "NT 4" checkNotPossible		
			Call checkCodecs
	goto endCheckCodecs

	checkNotPossible:
		ReadINIStr $1 $EXEDIR\autorun.ini CodecVideo check
		StrCmp $1 "yes" 0 skipCheckCodecs
			ReadINIStr $1 $EXEDIR\autorun.ini CodecAudio check
			StrCmp $1 "yes" 0 skipCheckCodecs
				MessageBox MB_OK "Codecs check is not possible on this OS."
	goto endCheckCodecs

	endCheckCodecs:
	skipCheckCodecs:
	ReadINIStr $1 $EXEDIR\autorun.ini MDVDP check
	StrCmp $1 "yes" 0 skipCheckMDVD
		Call checkMDVD
	skipCheckMDVD:
SectionEnd ; end the section


; eof